function scriptedHomeFront(faction, front, AIPlayer)
  if faction.id == 1 then
    local france = game:GetFactionById(0)
    if france.alliance.id == faction.alliance.id 
    and AIPlayer:isHomeFront(front,france) then
      return true
    end
  end

  
  end


-- For the following three functions, return true as a second parameter if the purchase is high priority.
function scriptedTargetRailCapacity(faction)
  if faction.id == 0 and game.turn >= 5 then
     return 1
  end
  if faction.id == 4 and game.turn >= 6 then
    return 1
  end
end

function scriptedTargetTransportCapacity(faction)
  if faction.id == 10 then
  --  return 3,true
  end 
end

function scriptedTargetAmmoFactories(faction)
  
end

function scriptedAIMovementCost(unit,hex)
  local paris = GetHex(82,30)
  local antwerp = GetHex(85,24)

  if game.turn < 10 and unit.hex ~= nil and unit.faction.id == 2 then
    if (not(unit.hex.x == 89 and unit.hex.y >= 28)) or (not(unit.hex.x == 90 and (unit.hex.y == 31 or unit.hex.y == 32))) then
    
      local unitDistanceToParis = unit.hex:Distance(paris)
     if antwerp.alliance ~= unit.alliance then
        local hexDistanceToAntwerp = hex:Distance(antwerp)
        if hexDistanceToAntwerp <= unit.range or unit.range > 1 then
          return (hexDistanceToAntwerp+5)*2*unit.hp
        elseif unitDistanceToParis <= 15 then
          local hexDistanceToParis = unit.hex:Distance(paris) + math.max(0,hex.x-82)
          return hexDistanceToParis*2*unit.hp
        end
    end
  end
  end
  
  if game.turn < 4 and unit.hex ~= nil and unit.range == 1 and unit.faction.id == 3 then
    local skopje = GetHex(111,44)
    local hexDistanceToSkopje = unit.hex:Distance(skopje)
    if hexDistanceToSkopje <= 9 then
      return hexDistanceToSkopje*2*unit.hp
    end
  end

  if game.turn < 2 and unit.hex ~= nil and unit.faction.id == 7 then
    if hex.y < 38 or (hex.y ==38 and hex.x == 110) then
      return 10000
    end
  end
  return 0
end

function scriptedAIAggressiveMultiplier(front,AIPlayer)
      local france = game:GetFactionById(0)
      local russia = game:GetFactionById(4)
	    local paris = GetHex(82,30)

  
  if playerAlliance.id == 1 
		and paris.alliance.id == 1 
		and GetEvent("Tannenberg") == 0 then
    
	local distanceToParis = AIPlayer:getDistanceToFront(paris,front)
			if distanceToParis <= 10 then
		  --    LogUi("!!!!!! Parisaggro!!!!!!")
			  return 1 ------------- 2.5 --2 --3 --1 -- 2.5--2.5
			end
    
	
	local warsaw = GetHex(112,23)
	local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
			if distanceToWarsaw <= 10 
			and russia.alliance.id == 1 
			and GetEvent("Tannenberg") == 0 then
				return 1 -- --1 -- 2.5--2.5
			
			elseif  russia.alliance.id == 1 
			and GetEvent("Tannenberg") >0 
			and GetEvent("WarsawCaptured") == 0 then --and gameplay.winter == 0 then
				--	      LogUi("!!!!!! Warsawaggro 2.5 !!!!!!")

				return 1.5 ------------------3
			elseif GetEvent("RussiaSupplyCrisis") >0 then
			--      LogUi("!!!!!! Warsawaggro 2 !!!!!!")

			return 0.75 --1
			end
	
	
	
	local belgrade = GetHex(109,38)
    local distanceToBelgrade = AIPlayer:getDistanceToFront(belgrade,front)
					if distanceToBelgrade <= 3 then --  and ((GetEvent("SerbianTyphoid") == 0 and GetEvent("BelgradeCaptured") == 0) and GetEvent("AustriaInvasion") == 0) then
						--	LogUi("!!!!!! Belgrade 2.5 aggro!!!!!!")

							return 2 --2.5 --2.5

					else
					--      LogUi("!!!!!! Belgrade 1.5 aggro!!!!!!")

					return 1---------------------------1.5 -- 2.5
					end
  end
 -- LogUi("!!!!!! OTHER FRONT aggro!!!!!!")

  return 1 ----- 2
end

function scriptedAITargettingBias(unit,unitHex,target,targetHex,front)
local france = game:GetFactionById(0)
local germany = game:GetFactionById(2)
local belgium = game:GetFactionById(6)

local calais = GetHex(82, 26)
local reims = GetHex(85, 28)
local amiens = GetHex(82, 28)	  

local paris = game:GetHex(82, 30)
local warsaw = game:GetHex(112, 23)

local toul = game:GetHex(87, 31)
local belfort = game:GetHex(89, 32)
local verdun = game:GetHex(87,29)


local aiinfrancecounter = 0
local aimaxinfrancecounter = 0
	for hex in germany.hexes do
		
		if hex.originalFaction.id == france.id and hex.unit ~= nil and hex.unit.alliance.id == 2 then
			aiinfrancecounter = aiinfrancecounter +1
		end	
	end
	
if calais.alliance.id == 1 then 
	aiinfrancecounter = aiinfrancecounter -2
end
if amiens.alliance.id == 1 then 
	aiinfrancecounter = aiinfrancecounter -2
end
if reims.alliance.id == 1 then 
	aiinfrancecounter = aiinfrancecounter -2
end
if paris.alliance.id == 1 then 
	aiinfrancecounter = aiinfrancecounter -4
end


---#1

  if unit.alliance.id == 2 
	and GetEvent("DOWfrance") == 0 
	and GetEvent("Cossacks") == 0 
	and target.faction.id == 7 then
    if targetHex ~= nil and targetHex.construction ~= nil and GetConstructionProduction(targetHex.construction) >= 0 then
 --     LogUi("TARGET#1")
	  return 10*front.advantage -- serbs get attacked
    end
 end
 
--#2 
 if unit.alliance.id == 2 
	and GetEvent("DOWfrance") > 0 
	and game.date.year == 1914 
	and (GetEvent("Cossacks") == 0 or GetEvent("Rupprecht") > 0) 
	and (target.faction.id == 0 or target.faction.id == 6 or target.faction.id == 1) then
    if targetHex ~= nil and targetHex.construction ~= nil and GetConstructionProduction(targetHex.construction) >= 0 then
   --    LogUi("TARGET#2")
	  return 10*front.advantage --- Western Front attacked
    end
 end
 
 --#3
	if unit.alliance.id == 2 
		and GetEvent("Cossacks") > 0 
		and game.date.year == 1914 
		and gameplay.winter == 0 
		and GetEvent("Tannenberg") == 0 
		and target.faction.id == 4 then
		if targetHex ~= nil and targetHex.construction ~= nil and GetConstructionProduction(targetHex.construction) >= 0 then
			LogUi("TARGET#3")
		return 10*front.advantage  -- Russia gets attacked
		end
	end
 --#4
  if unit.alliance.id == 2 
	and GetEvent("Tannenberg") > 0 
	and game.date.year == 1914 
	and ((GetEvent("Moltke") == 0 
			and (target.faction.id == 0 or target.faction.id == 1 or target.faction.id == 6))  
	or (GetEvent("Rupprecht") > 0 and (toul.alliance.id == 1 or belfort.alliance.id == 1) 
			and verdun.alliance.id == 1)) then
    if targetHex ~= nil and targetHex.construction ~= nil and GetConstructionProduction(targetHex.construction) >= 0 then
		LogUi("TARGET#4")     
	 return 10*front.advantage --- france gets attacked
    end
 end
--#5 
	if unit.alliance.id == 2 
		and GetEvent("Tannenberg") > 0 
		and game.date.year == 1914 
		and GetEvent("Moltke")  >0 
		and (target.faction.id == 0 or target.faction.id == 6 or target.faction.id == 1) then
    if targetHex ~= nil and targetHex.construction ~= nil and GetConstructionProduction(targetHex.construction) >= 0 then
	   LogUi("TARGET#5")
	  return 10*front.advantage
    end
 end
--#6
  if unit.alliance.id == 2 
	and GetEvent("Tannenberg") > 0 
	and game.date.year >= 1915 
	and germany.luaData.maxinfrance == 0
	and aiinfrancecounter < game.turn 
	and (target.faction.id == 0 or target.faction.id == 6 or target.faction.id == 1) then
    if targetHex ~= nil and targetHex.construction ~= nil and GetConstructionProduction(targetHex.construction) >= 0 then
        LogUi("TARGET#6")
	  return 10*front.advantage
    end
 end
  --#7

  if unit.alliance.id == 2 
		and game.date.year >= 1915 
		and germany.luaData.maxinfrance == 0 then
	if  (target.faction.id == 0 
		or target.faction.id == 1 
		or target.faction.id == 6) then
		
		if targetHex ~= nil and targetHex.construction ~= nil 
			and GetConstructionProduction(targetHex.construction) >= 0 then
		  LogUi("TARGET#7 WEST")
		return 10*front.advantage
		end
	elseif target.faction.id == 4 then
		LogUi("TARGET#7 EAST")
		return 10*front.advantage
		
	else
		return 10*front.advantage
	
		
	end
 

end
  return 0
end
function scriptedAIFrontBias(front,AIPlayer)
		local france = game:GetFactionById(0)
        local russia = game:GetFactionById(4)
		local serbia = game:GetFactionById(7)
        local bulgaria = game:GetFactionById(19)
		local romania = game:GetFactionById(18)

		local switzerland = game:GetFactionById(17)

		
		local paris = GetHex(82,30)
		local warsaw = GetHex(112,23)
		local belgrade = GetHex(109,38)
		local lemberg = GetHex(115,28)

					
					
 if front.type ~= frontType.Sea then
    
	
	if playerAlliance.id == 1 then
 
---------------------------------------------
 ---WF
 
	if france.alliance.id == 1 and russia.alliance.id == 0 then
        local distanceToParis = AIPlayer:getDistanceToFront(paris,front)
			if distanceToParis < 15 then--20 then
				LogUi("PARIS FRONT 1")
				return 1200 --25 -- 1000
			end
 
	elseif france.alliance.id == 1 
		and russia.alliance.id == 1 
		and GetEvent("Moltke") == 0 then
        local distanceToParis = AIPlayer:getDistanceToFront(paris,front)
			if distanceToParis < 15 then-- then
				LogUi("PARIS FRONT 2")
				return 1100 -- 50 -- 900
			end
 
	elseif france.alliance.id == 1 
			and russia.alliance.id == 1 
			and (GetEvent("Moltke") > 0 ) 
			and GetEvent("Tannenberg") == 0 then
        local distanceToParis = AIPlayer:getDistanceToFront(paris,front)
			if distanceToParis < 15 then -- then
				LogUi("PARIS FRONT 3")
				return  1000 -- -- 950
			end
	elseif france.alliance.id == 1 
			and russia.alliance.id == 1 
			and (GetEvent("Rupprecht") > 0 )
			and switzerland.alliance.id ==1	then
			
        local distanceToParis = AIPlayer:getDistanceToFront(paris,front)
			if distanceToParis < 15 then -- then
				LogUi("PARIS FRONT 4")
				return  1200 -- -- 950
			end		
	elseif france.alliance.id == 1 
			and russia.alliance.id == 1 
			and (GetEvent("Rupprecht") > 0 )
			and switzerland.alliance.id ==0	then
			
        local distanceToParis = AIPlayer:getDistanceToFront(paris,front)
			if distanceToParis < 15 then -- then
				LogUi("PARIS FRONT 4")
				return  1000 -- -- 950
			end		
	
	elseif france.alliance.id == 1 
			and russia.alliance.id == 1 
			and (GetEvent("AllEast") > 0 )
			and switzerland.alliance.id ==0	then
			
        local distanceToParis = AIPlayer:getDistanceToFront(paris,front)
			if distanceToParis < 15 then -- then
				LogUi("PARIS FRONT 5")
				return  900  -- -- 950
			end		
	
	end
 
 ------------------------------------------     
--EF 

 if russia.alliance.id == 0 and GetEvent("AllEast") <0 then 
        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
			if distanceToWarsaw < 11 then--15 then
				LogUi("WARSAW FRONT 1")
				return 900
			end
elseif russia.alliance.id == 1  and GetEvent("AllEast") >0 then 
        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
				LogUi("WARSAW FRONT 2")
				if distanceToWarsaw < 15 then --11 then --15 then
			
				return 1300 --750 --900 --50 --900
				end			
      
elseif russia.alliance.id == 1 
	and GetEvent("Tannenberg") == 0 then 
        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
				LogUi("WARSAW FRONT 2")
				if distanceToWarsaw < 15 then --11 then --15 then
			
				return 1200 --750 --900 --50 --900
				end
			
elseif russia.alliance.id == 1 
		and GetEvent("Tannenberg") > 0 
		and bulgaria.alliance.id == 0
		and (GetEvent("RussiaSupplyCrisis") == 0 or GetEvent("WarsawCaptured") == 0) then 
        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
				if distanceToWarsaw < 15 then -- 11 then--15 then
				LogUi("WARSAW FRONT 3")
					return 1100 --900 --75 -- 900
				end
elseif russia.alliance.id == 1 
		and (bulgaria.alliance.id == 2 or romania.alliance.id == 2)
		and GetEvent("RussiaSupplyCrisis") == 0 
		and GetEvent("WarsawCaptured") == 0 then 
        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
				if distanceToWarsaw < 15 then -- 11 then--15 then
				LogUi("WARSAW FRONT 4")
					return 1200 --900 --75 -- 900
				end

				
elseif russia.alliance.id == 1 
		
			and GetEvent("RussiaSupplyCrisis") > 0 
			and GetEvent("RussiaSupplyCrisisEnd") == 0 then
        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
				if distanceToWarsaw < 15 then -- 11 then--15 then
				LogUi("WARSAW FRONT 5")
					return 1500 --900 --75 -- 900
				end			  

elseif russia.alliance.id == 1 
		 
			and GetEvent("RussiaSupplyCrisisEnd") > 0
			and GetEvent("WarsawCaptured") == 0 then 

        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
				if distanceToWarsaw < 15 then -- 11 then--15 then
				LogUi("WARSAW FRONT 5")
					return 1400 --900 --75 -- 900
				end			  
elseif russia.alliance.id == 1 
		
			 
			and GetEvent("RussiaSupplyCrisisEnd") > 0
			and GetEvent("WarsawCaptured") > 0 then 

        local distanceToWarsaw = AIPlayer:getDistanceToFront(warsaw,front)
				if distanceToWarsaw < 15 then -- 11 then--15 then
				LogUi("WARSAW FRONT 5")
					return 1200 --900 --75 -- 900
				end			  
end

 
	  
	  
 ----------------------------------------------     
if serbia.alliance.id == 1 then  
	
	if game.turn <= 2 then
        
        local belgrade = GetHex(109,38)
        local distanceToBelgrade = AIPlayer:getDistanceToFront(belgrade,front)
          if distanceToBelgrade < 3 then
            return 10
          end
       
	elseif game.turn >= 3 and GetEvent("SerbianTyphoid") == 0 and belgrade.alliance.id == 1 then
			local distanceToBelgrade = AIPlayer:getDistanceToFront(belgrade,front)
			if distanceToBelgrade < 2 then
		--	LogUi("BELGRADE FRONT")
			return 25 ---50
			end
     elseif game.turn >= 3 and (GetEvent("SerbiaMoral") >0 or belgrade.alliance.id == 2) then
			local distanceToBelgrade = AIPlayer:getDistanceToFront(belgrade,front)
            if distanceToBelgrade < 2 then
		--	LogUi("BELGRADE FRONT")
			return 10 --25
			end
     end
    
end	
-------------------------------------------------	
	
	
	--LogUi("?????????????????????????????????????????????WHOOOOOPS!!!!!?????????????????????????????????????????????????")
	
	end

	
	
	
	---------------------------------------------------------------------------------------------------------------------------------------    
    if playerAlliance.id == 2 then
      local caucasus = GetHex(150,46) -- near sarikamish
      local distanceToCaucasus = AIPlayer:getDistanceToFront(caucasus,front)
      if distanceToCaucasus < 10 then
        local turkey = game:GetFactionById(5)
						if turkey.alliance.id ~= game:GetAllianceById(1).id then
									--printLog("don't react to turkey russia!")
							--		LogUi("----------russia reacting in caucasus!----------------")
									
									if GetEvent("AllEast") <= 0 then
										return  -15 --0  -- 25 --- -50  ----20   -- -10 --50
									else
										return  -50 --0  -- 25 --- -50  ----20   -- -10 --50

									end
						else
						
						local grozni = GetHex(152,40)
						local nearestEnemyDist = AIPlayer:getDistanceToAlliance(game:GetAllianceById(1),grozni)
							if nearestEnemyDist > 9 then
							LogUi("----------caucasus safe!----------------")

								return  -25 --10
							end
						end
		end
    end
  end
  return 0
end

function scriptedNavalInvasions(self)
  if playerAlliance.id == 2 then
    local britain = game:GetFactionById(1)
    if britain.alliance.id == ui.enemyAlliance.id then
      local unitsInBritain = {}
      for unit in britain.units do
        if unit.type == Unit.LAND and unit.hex ~= nil and unit.hex.originalFaction.id == britain.id then
          table.insert(unitsInBritain,unit)
        end
      end
              
      if #unitsInBritain > 2 and (self.sai.scriptedFlag1 == nil or self.sai.scriptedFlag1 + 10 < game.turn) then
        local paris = GetHex(82,30)
        local front, dist
        front, dist = self:getNearestEnemyFront(paris)
        if front ~= nil and dist < 20 and (front.advantage > 1 or front.full == true) and self:nai_IsRegionSafe(ui.enemyAlliance,1) > 1 then
          local target = GetHex(93,20)
          if self:getDistanceToAlliance(self.sai.alliance,target) > 5 then
            self:doNavalInvasion(unitsInBritain,{target},3)
            if self.sai.scriptedFlag1 == nil or self.sai.scriptedFlag1 + 10 < game.turn then
              self.sai.scriptedFlag1 = game.turn
            end
          end
        end
      end
      
      if game.turn > 7 and GetHex(97,57).unit ~= nil and GetFactionTransportmoves(britain) - #unitsInBritain > 1 then
        self:doNavalInvasion({GetHex(97,57).unit},{GetHex(107,47)}) -- Malta -- Old target egypt GetHex(125,66)
      end
      
      if GetHex(97,57).unit == nil and game.turn > 7 and GetHex(61,55).unit ~= nil and GetFactionTransportmoves(britain) - #unitsInBritain > 1 then
        self:doNavalInvasion({GetHex(61,55).unit},{GetHex(107,47)}) -- Gibraltar
      end
    end
  end
end

function scriptedIdleUnits()
LogUi("SCRIPTED IDLE START")
  local units = {}
  if playerAlliance.id == 2 then
    -- Entente AI
    if game.turn <= 4 then
      local serbia = game:GetFactionById(7)
      for unit in serbia.units do
        if unit.alive and unit.hex ~= nil and unit.hex.x <= 109 then
          table.insert(units,unit)
        end
      end
    elseif game.turn < 6 then
      local belgradeInf = GetHex(109,38).unit
      if belgradeInf ~= nil and belgradeInf.hp == 100 and belgradeInf.alliance == 1 then
        table.insert(units,belgradeInf)
      end
    end
    
    if game.turn >=3 then
      local france = game:GetFactionById(0)
      local parisUnit = GetHex(82,30).unit
      if parisUnit ~= nil then
        table.insert(units,parisUnit)
        france:ConsumeProductionPoints(-3)
      end
    end
    
    local malta = GetHex(97,57)
    local gibraltar = GetHex(61,55)
    if malta.unit ~= nil or gibraltar.unit ~= nil then
      local britain = game:GetFactionById(1)
      local france = game:GetFactionById(0)
      if france.alliance.id == 1 then
        local unitsInBritain = {}
        for unit in britain.units do
          if unit.type == Unit.LAND and unit.hex ~= nil and unit.hex.originalFaction.id == britain.id then
            table.insert(unitsInBritain,unit)
          end
        end
       -- if #unitsInBritain > 0 then
        --  table.insert(units,gibraltar.unit)
        --end
       -- if #unitsInBritain > 1 and game.turn < 10 then
        --  table.insert(units,malta.unit)
        --end
      end
    end
  ---------------------------------------------------------- IDLE CP
  elseif playerAlliance.id == 1 then
    -- CP Ai
    
	if game.turn >= 1 and game.turn <= 4 then
      table.insert(units,GetHex(102,41).unit) --predred
--	table.insert(units,GetHex(106,45).unit) --sub
    table.insert(units,GetHex(99,37).unit) --dread
    
	end
	
	
	if game.turn >= 1 and game.turn < 6 then
      table.insert(units,GetHex(113,27).unit) --prz
      table.insert(units,GetHex(118,28).unit) -- tarno

	  
    end
	
	if game.turn >= 1 and game.turn < 7 then
      table.insert(units,GetHex(110,27).unit) --krakow
	  table.insert(units,GetHex(115,28).unit) --lemberg
      table.insert(units,GetHex(113,27).unit)
     
    end
	
	
	
	
	
	
    if game.turn >= 3 and game.turn <= 9 then
      table.insert(units,GetHex(112,17).unit) --konigs
	  table.insert(units,GetHex(114,19).unit) --lotz
	  table.insert(units,GetHex(90,32).unit) -- voges1
	  table.insert(units,GetHex(90,31).unit) --voges2
	  table.insert(units,GetHex(90,30).unit) ---strassburg
	  table.insert(units,GetHex(89,29).unit) --- metz

	  table.insert(units,GetHex(113,16).unit) --above konigs
	 

	  
	  
	  

    elseif game.turn == 4 or game.turn == 5 then
      
      table.insert(units,GetHex(111,19).unit)
    end
    if game.turn >= 5  and game.turn <= 10 then
    end


    if game.turn == GetFactionDateJoined(game:GetFactionById(5)) then
      turkey = game:GetFactionById(5)
    --  for unit in turkey.units do
    --    if unit.alive then
    --      table.insert(units,unit)
    --    end
     -- end
    end
  end
  LogUi("SCRIPTED IDLE END")

  return units
end

function scriptedManualMoves(AIPlayer)
local warsaw = game:GetHex(112, 23)
local paris = game:GetHex(82, 30)

local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
local germany  = game:GetFactionById(2)
local belgrade = game:GetHex(109, 38)
local bulgaria  = game:GetFactionById(18)

local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)
local turkey = game:GetFactionById(5)
local belgium = game:GetFactionById(6)
local serbia = game:GetFactionById(7)
local italy = game:GetFactionById(8)
local netherlands = game:GetFactionById(9)
local usa = game:GetFactionById(10)
local sweden = game:GetFactionById(11)
local denmark = game:GetFactionById(12)
local finland = game:GetFactionById(13)
local greece = game:GetFactionById(14)
local spain = game:GetFactionById(15)
local portugal = game:GetFactionById(16)
local switzerland = game:GetFactionById(17)
local romania = game:GetFactionById(18)
local bulgaria = game:GetFactionById(19)
local norway = game:GetFactionById(20)
local persia = game:GetFactionById(22)
local arabia = game:GetFactionById(21)
local egypt = game:GetFactionById(26)
---------------------------------------------- PLAYER IS CP
 if AIPlayer.alliance.id == 1 then
    if game.turn == 1 then
	
      return  {
                -- Bring up Serbian reserves to Nis
                {{112,41}, {112,39}},
              }
    elseif game.turn == 3 and math.random(1,3) >= 2 then
      return  {
                -- Move french reserves north
                	{{76,7}, {79,2}},
					{{72,14}, {67,10}},
					{{71,26}, {79,26}},
					{{86,26}, {84,27}},   
				     {{84,26}, {85,26}},

					  {{82,26}, {85,26}},   
					  {{82,30}, {84,28}},   

				{{87,29}, {86,28}},
				{{87,31}, {87,29}},
				{{88,29}, {87,28}},
				{{88,30}, {88,29}},
				{{79,23}, {83,25}},
				{{79,22}, {79,23}},
				{{76,25}, {82,27}},
                -- Move british troops to ports
                {{79,23}, {82,26}}, -- Embark in London
          --      {{79,22}, {79,23}},
                {{76,22}, {76,25}},
              }	  
			  		  
	elseif game.turn == 4 then
      return  {
                -- Embark british troops
              --  {{79,23}, {82,26}}, -- Embark in London
                {{76,25}, {82,27}}, -- Embark in Portsmouth
              }
  	


	
	elseif game.turn >= 4 and GetEvent("FrenchArmyOfAfrica") > 0 then
		      return  {
                
                {{76,54}, {86,40}},
				
              }			  
    
	elseif game.turn == 5 then
	return {
	 {{119,26}, {118,28}},
	{{76,7}, {79,2}},
	{{119,26}, {118,28}},
	{{119,26}, {118,28}},
	
	
	
	}
	
	elseif game.turn >=6 then
	 	local returnValues = {}

		if game.turn >= 6 then -- AI scripted targeting
		LogUi("SCRIPTED TARGETING START")
				for faction in entente.factions do
						for unit in faction.units do
						
							if unit.hex ~= nil 
								and unit.prototype.name == "artillery" 
								and unit.efficiency ~= nil 
								and unit.hp >= 70 
								and faction.am >= 10 
								and unit.ap >0 then
								
								local enemyinrange = 0	
								local adjacentHexes = game.map:GetHexesInRange(unit.hex, 1)
									for _, hex in pairs(adjacentHexes) do
											if hex.unit ~= nil 
													and hex.unit.alive 
													and hex.unit.alliance.id ~= unit.alliance.id 
													and (hex.unit.prototype.name == "infantry" 
														or hex.unit.prototype.name == "cavalry") then
												enemyinrange = 1
												break
											end
									end		 	
											local ahex = unit.hex
											local hexes = game.map:GetHexesInRange(ahex, 2)
												for _, bhex in pairs(hexes) do
														if bhex.unit ~= nil 
														and bhex.unit.type == Unit.LAND 
														and bhex.unit.alliance.id == 2
														and enemyinrange == 0	
														and ((bhex.construction ~= nil and bhex.unit.hp >= 40) or ((bhex.unit.prototype.name == "infantry" and bhex.unit.hp >= 50) or bhex.unit.prototype.name ~= "infantry" and bhex.unit.commander ~= nil))
														then
																	LogUi("CHECKING ARTY FROM:" .. ahex.x ..  "/" .. ahex.y .. "TO:" .. bhex.x .. "/" .. bhex.y)
																		
																			table.insert(returnValues,{{ahex.x, ahex.y}, {bhex.x, bhex.y}})
																			break
																					
																					
							
														end
												end		
							end
							if unit.hex ~= nil and unit.prototype.name == "fighter" and unit.hp >= 60 and unit.efficiency ~= nil and unit.efficiency >= 50 and unit.ap >0 then
						local enemyinrange = 0	
								local adjacentHexes = game.map:GetHexesInRange(unit.hex, 2)
									for _, hex in pairs(adjacentHexes) do
											if hex.unit ~= nil 
													and hex.unit.alive 
													and hex.unit.alliance.id ~= unit.alliance.id 
													and (hex.unit.prototype.name == "infantry" 
														or hex.unit.prototype.name == "cavalry") then
												enemyinrange = 1
												break
											end
									end		 	
											local ahex = unit.hex
											local hexes = game.map:GetHexesInRange(ahex, 5)
												for _, bhex in pairs(hexes) do
														if bhex.unit ~= nil 
														and bhex.unit.type == Unit.LAND 
														and bhex.unit.alliance.id == 2
														and enemyinrange == 0
														and ((bhex.construction ~= nil and bhex.unit.hp >= 60) or ((bhex.unit.prototype.name == "infantry" and bhex.unit.hp >= 50) or bhex.unit.prototype.name ~= "infantry" and bhex.unit.commander ~= nil))
														then
																	LogUi("CHECKING FIGHTER FROM:" .. ahex.x ..  "/" .. ahex.y .. "TO:" .. bhex.x .. "/" .. bhex.y)
																		
																			table.insert(returnValues,{{ahex.x, ahex.y}, {bhex.x, bhex.y}})
																			break
																					
																					
							
														end
												end		
							end
							if unit.hex ~= nil and (unit.prototype.name == "zeppelin" or unit.prototype.name == "bomber")  
							and unit.hp >= 60 
							and unit.ap >0 
							and unit.efficiency ~= nil 
							and unit.efficiency >= 40 
							and unit.faction.am >= 24 then
								local enemyinrange = 0	
								local adjacentHexes = game.map:GetHexesInRange(unit.hex, 2)
									for _, hex in pairs(adjacentHexes) do
											if hex.unit ~= nil 
													and hex.unit.alive 
													and hex.unit.alliance.id ~= unit.alliance.id 
													and (hex.unit.prototype.name == "infantry" 
														or hex.unit.prototype.name == "cavalry") then
												enemyinrange = 1
												break
											end
									end		
											local ahex = unit.hex
											local hexes = game.map:GetHexesInRange(ahex, 16)
											if unit.prototype.name == "bomber" then
												hexes = game.map:GetHexesInRange(ahex, 14)
											end
												for _, bhex in pairs(hexes) do
													--	if bhex.unit ~= nil 
													--	and bhex.unit.type == Unit.LAND 
													--	and bhex.unit.alliance.id == 1 
														if bhex.terrain.type ~= Terrain.WATER
														and (bhex.construction ~= nil 
														and bhex.construction.efficency ~= nil
														and bhex.construction.efficency > 50) 
														and bhex.alliance ~= nil 
														and bhex.alliance.id == 2
														and enemyinrange == 0
														then
																	LogUi("CHECKING ZEP/BOMBER FROM:" .. ahex.x ..  "/" .. ahex.y .. "TO:" .. bhex.x .. "/" .. bhex.y)
																		
																			table.insert(returnValues,{{ahex.x, ahex.y}, {bhex.x, bhex.y}})
																			break
																					
																					
							
														end
												end		
							end
						
						end	
				end
		
				LogUi("SCRIPTED TARGETING END")

		
		end
		
		return returnValues
	
	
end	

end 
 
 -------------------------------------------------------------------------------------------------------------------------- CP MOVES
 
  if AIPlayer.alliance.id == 2 then
   	local warsaw = game:GetHex(112, 23)
		local cp =  game:GetAllianceById(2)

----------------------------------------------------------


   if game.turn == 1 and GetEvent("Surrenderserbia") == 0 then
      local returnValues = {
              --  {{114,28}, {115,27}}, -- from Przemysl
				{{111,37}, {109,38}},      -- art at belg         
			   {{105,37}, {107,37}},
				{{107,37}, {107,38}}, --pot att
			 {{105,36}, {106,38}},
			 {{106,38}, {107,38}},
			 {{106,37}, {106,39}},
			 {{106,39}, {107,38}},
			 {{108,34}, {109,36}},
			 
			 {{108,34}, {109,36}},
			 {{107,32}, {108,35}}, --art
			 {{117,28}, {111,37}}, --n cav
			 {{105,42}, {106,43}}, --armcr
			 {{106,43}, {107,42}},--armcr cetinje
			 {{104,37}, {105,30}}, --fighter
			 }

               return returnValues
		
	  end

----------------------------------------------------------------------------------------------------- 2	
	if game.turn == 2 and GetEvent("Surrenderserbia") == 0 then
      
      
		--if GetHex(107,38).unit ~= nil and GetHex(108,39).unit ~= nil then
        local returnValues = {
						{{111,37}, {109,38}},               
					{{107,37}, {109,37}},	 
					{{105,38}, {105,40}},
					{{108,35}, {108,37}},	--art			
					{{109,36}, {110,38}},
					{{106,39}, {107,38}},
					{{106,38}, {108,38}},
					{{106,43}, {107,42}},--armcr cetinje

              }

    		      return returnValues

	end
--------------------------------------------------------------------------------------------------- 3	
	if game.turn == 3 then
	
	if GetEvent("Rupprecht") >0 then
	 local returnValues = {
			{{95,20}, {91,23}}, --zep
			{{91,30}, {89,31}}, -- arty	         
            {{89,30}, {89,31}},					 
			 {{90,31}, {89,31}},	-- bulow
			  {{90,32}, {89,31}, "advance"}, -- kluck
			  	  {{93,31}, {91,32}}, -- 2nd arty
				 	  {{91,31}, {90,32}}, -- hausen
					     {{90,32}, {91,32}}, -- hausen
						{{92,31}, {91,31}}, 
						 {{91,31}, {91,32}, "advance"}, 
						  {{89,29}, {88,29}},	
							{{89,28}, {88,29},"advance"},								  
						  
				  
		 }

    		      return returnValues

	
	
	
	
	
	
	elseif GetEvent("Redeploy") >0 then
      local returnValues = {
               --	{{106,43}, {107,42}},--armcr cetinje
				{{95,20}, {91,23}}, --zep

				{{90,25}, {88,26}}, 	--liege		           
                {{90,27}, {88,26}},		--liege			     
                {{89,25}, {87,25}},
			   {{91,25}, {89,25}},
			   {{89,25}, {88,26}},
                {{91,26}, {89,26}},
				{{89,26}, {88,26}},
				{{90,28}, {88,27}},
								{{88,27}, {88,26}},

                {{90,26}, {87,26}},
				{{91,27}, {89,27}},

				{{87,26}, {88,26}},             
				{{87,25}, {88,26}, "advance"}, 
                {{90,29}, {89,28}},

			   {{108,37}, {109,38}},-- Bombard belgrade
			   {{110,38}, {109,38}}, -- belgrade			
				{{108,38}, {109,38}}, --belgrade
				
				{{113,19}, {113,20}}, --garr
                {{112,20}, {112,21}},-- garr
				{{110,19}, {110,21}}, -- danz garr
				       {{112,18}, {113,18}},   

			--	{{112,19}, {111,18}},
   
				{{92,28}, {91,26}},   
				{{105,42}, {106,47}},   
				{{111,38}, {110,39}},   
				{{111,37}, {111,38}},   
			--	{{91,24}, {87,24}},
              --  {{89,30}, {107,24}},-- already on eastfront 
			--	{{92,25}, {88,26}}, ditto  


	    
--navy
       {{111,14}, {112,15}},   
       {{110,18}, {111,15}},   
       {{94,19}, {96,12}},   
    --   {{103,19}, {94,13}},   

  }
			
							
 
           return returnValues

else		   
		
local returnValues = {
               --	{{106,43}, {107,42}},--armcr cetinje

				{{90,25}, {88,26}}, 	--liege		           
                {{90,27}, {88,26}},		--liege			    
                {{89,25}, {87,25}},
				{{91,25}, {89,25}},
				{{89,25}, {88,26}},
				{{91,24}, {88,25}},	
				{{88,25}, {88,26}},
                {{91,26}, {89,26}},
                {{89,26}, {88,26},"advance"},
				{{90,26}, {87,26}},
				{{90,29}, {89,28}},
				{{90,28}, {88,28}},
				{{88,28}, {87,27},"advance"},
				{{91,27}, {89,27}},
				{{89,30}, {90,29}},
				{{92,25}, {90,26}},		  
				{{95,20}, {91,23}}, --zep
				{{87,26}, {86,26}, "advance"},             
				{{87,25}, {86,26}, "advance"}, 
	
				{{108,37}, {109,38}},-- Bombard belgrade
				{{110,38}, {109,38}}, -- belgrade			
				{{108,38}, {109,38}}, --belgrade
				
				{{113,19}, {113,20}}, --garr
                {{112,20}, {112,21}},-- garr
				{{110,19}, {110,21}}, -- danz garr
			  {{112,18}, {113,18}},  -- cav
			  {{112,17}, {113,17}},   --kberg garr
			  

				{{112,19}, {111,18}}, --plane
   
				{{92,28}, {91,26}},   
				{{105,42}, {106,47}},   
				{{111,38}, {110,39}},   
				{{111,37}, {111,38}},   
				
		--navy		
		{{111,14}, {112,15}},   
       {{110,18}, {111,15}},   
       {{92,19}, {96,12}},   
     --  {{103,19}, {94,13}},   


	

}
			
							
 
           return returnValues
	
		   
end		   
end
										

			 





if game.turn == 4 then
		
-- west	

if GetHex(88,29).unit == nil then 
      local returnValues = {
	
		{{89,28}, {88,29}},
		{{89,27}, {88,28}},
		{{88,28}, {87,27}},
		{{87,25}, {86,26},"advance"},
		{{88,27}, {87,27}},
		{{87,26}, {87,28},"advance"},
		{{89,25}, {87,26}},
		{{87,26}, {86,27}},
		{{89,26}, {86,27}},
		{{86,27}, {86,28},"advance"},
		{{87,24}, {86,27}},
		{{86,27}, {85,27},"advance"},
		{{88,26}, {86,26}},
		{{86,26}, {85,26}},	
		{{90,27}, {89,27}},
		{{90,25}, {88,26}},
			 {{108,37}, {109,38}},
		{{108,36}, {109,38}},-- Bombard belgrade
		{{109,36}, {109,38}}, -- Bombard belgrade		
	 {{109,37}, {109,38}},               
 {{110,38}, {109,38},"advance"},               
 {{108,38}, {109,38}},   	
	 {{107,24}, {108,22}},   			
	       {{111,38}, {110,39}},


}
			
	      return returnValues

		  
  elseif GetHex(86,25).unit ~= nil and GetHex(87,27).unit ~= nil then
		   local returnValues = {
	
		{{87,25}, {86,25}},
				{{88,25}, {86,25}},
		{{86,25}, {85,24},"advance"},
		{{88,28}, {88,27}},
		{{88,27}, {87,27}},
		{{89,28}, {88,28}},
	{{88,28}, {87,27}},
	{{87,26}, {87,27}},
	{{89,26}, {87,27}},
	{{87,27}, {89,26},"advance"},
	{{88,26}, {87,27}},
	{{87,27}, {86,27}},
	{{90,26}, {88,25}},
	{{88,25}, {87,24},"advance"},
	{{89,25}, {86,25}},
	{{86,25}, {86,26}},
	{{90,25}, {88,26}},
	{{90,29}, {89,28}},
	{{90,27}, {89,27}},
	{{108,36}, {109,38}},-- Bombard belgrade
		{{109,36}, {109,38}}, -- Bombard belgrade		
	 {{109,37}, {109,38}},               
 {{110,38}, {109,38},"advance"},               
 {{108,38}, {109,38}},   	
	 {{107,24}, {108,22}},   			
	       {{111,38}, {110,39}},


		
		}
			
  return returnValues
		  
	elseif GetHex(86,25).unit == nil and GetHex(88,28).unit ~= nil then
		   local returnValues = {
------------------------
{{86,26}, {85,27}},	--kluck	   
{{85,27}, {84,27}, "advance"},	
{{87,26}, {85,26}}, --bulow	
{{85,26}, {84,27}, "advance"},	
 {{88,26}, {85,25}},	
 {{88,25}, {86,27}},	
{{89,25}, {86,25}},	
{{89,26}, {87,26}},	
{{90,27}, {88,26}},	
{{90,25}, {87,25}},	
{{91,23}, {87,24}},	

		   

{{108,36}, {109,38}},-- Bombard belgrade
		{{109,36}, {109,38}}, -- Bombard belgrade		
	 {{109,37}, {109,38}},               
 {{110,38}, {109,38},"advance"},               
 {{108,38}, {109,38}},   	
	 {{107,24}, {108,22}},   			
	       {{111,38}, {110,39}},
	
		  
		}
			
  return returnValues
		  
		  
		  
		  
		  
end
	
 end
		

----------------------------------------------------------------------------------	
if game.turn >= 5 then
		local returnValues = {}
		
	if (game.turn == 5 or game.turn == 6 or game.turn == 7 or game.turn == 8) 
	and GetHex(89,28).unit == nil 
	and GetHex(89,27).unit ~= nil 
	and GetHex(89,27).unit.alliance.id == 2 
	and GetHex(89,27).unit.mp >0 then
				
		--	 table.insert(returnValues,{{89,27}, {89,28}})
			--	local returnvalues =  {	
			--			{{89,27}, {89,28}},
			--			}
				--	return returnvalues 
	end
	local hex = GetHex(89, 28)
 --[[f (game.turn == 5 or game.turn == 6 or game.turn == 7 or game.turn == 8)	and hex.unit == nil then
		local germany = game:GetFactionById(2)
		GetPlayer(SpawnUnit(0, germany, 89, 28, 0, 100))
				local hex = GetHex(89, 28)		
				if hex.unit ~= nil and hex.unit.faction.id == 2 then
						
					UpdateUnit(hex.unit)
				end
	end]]
------------------------------------------------------------------------------------	
	if game.turn == GetFactionDateJoined(game:GetFactionById(5))  then
      -- Opening moves for Ottomans
	
				
				table.insert(returnValues,{{133,65}, {132,66}})
				table.insert(returnValues,{{134,66}, {133,66}}) 
				table.insert(returnValues,{{134,67}, {133,67}})
								table.insert(returnValues,{{135,66}, {134,66}})

                
			  --  {{145,48}, {147,47}}, -- Erzurum advance
            --    {{144,48}, {146,47}}, -- Erzurum advance
			--	{{119,47}, {135,54}}, -- Erzurum advance
				
            
 	    
    end	  
	
----

	if game.date.year >= 1914 
		and belgrade.alliance.id == 1 
		and serbia.alliance.id == 1 
		and austria.alliance.id == 2 
		and (GetEvent("BulgariaAttack") >0 or GetEvent("SerbianTyphoid") >0 or bulgaria.alliance.id ==2) then
	
		for faction in cp.factions do
			for unit in faction.units do
							if unit.hex ~= nil and unit.type == Unit.LAND and unit.range == 1 and unit.ap > 0 and (unit.prototype.name == "infantry" or ((unit.prototype.name == "garrison" or unit.prototype.name == "cavalry") and belgrade.unit ~= nil and belgrade.unit.hp <= 60 )) then

		
										local ahex = unit.hex
										local hexes = game.map:GetHexesInRange(ahex, 1)
											for _, bhex in pairs(hexes) do
													if ((bhex.unit ~= nil and bhex.unit.alliance.id == 1) or bhex.unit == nil) and bhex.x == 109 and bhex.y == 38 and unit.hp >= 80 and unit.efficiency >= 60 then
															table.insert(returnValues, {{ahex.x, ahex.y}, {109, 38}, "advance"})
															LogUi("ASSAULTING BELGRADE")
																	break
													end
											end
								
			end
		end			 	      

		end
	end
	if paris.alliance.id == 1 then
	
		for faction in cp.factions do
			for unit in faction.units do
							if unit.hex ~= nil 
							and unit.type == Unit.LAND 
							and unit.range == 1 and unit.ap >0 
							and (unit.prototype.name == "infantry" 
								or unit.prototype.name == "garrison" 
								or unit.prototype.name == "cavalry") then

		
										local ahex = unit.hex
										local hexes = game.map:GetHexesInRange(ahex, 1)
											for _, bhex in pairs(hexes) do
													if ((bhex.unit ~= nil and bhex.unit.alliance.id == 1) or bhex.unit == nil) and bhex.x == 82 and bhex.y == 30 and unit.hp >= 80 and unit.efficiency >= 50 then
															table.insert(returnValues, {{ahex.x, ahex.y}, {82, 30}, "advance"})
														LogUi("ASSAULTING PARIS")
																	break
													end
											end
								
			end
		end			 	      

		end
	end
	

	if (GetEvent("RussiaSupplyCrisis") >0 
		or germany.luaData.funk >0 
		or GetEvent("MaxHoffmann") == game.turn) 
		and warsaw.alliance.id == 1 then
		
		for faction in cp.factions do
			for unit in faction.units do
									if  unit.hex ~= nil and unit.type == Unit.LAND and unit.range == 1 and (unit.prototype.name == "infantry" or unit.prototype.name == "garrison" or unit.prototype.name == "cavalry") and unit.ap >0 then

				
											local ahex = unit.hex
											local hexes = game.map:GetHexesInRange(ahex, 1)
												for _, bhex in pairs(hexes) do
														if ((bhex.unit ~= nil and bhex.unit.alliance.id == 1) or bhex.unit == nil) and bhex.x == 112 and bhex.y == 23 and unit.hp >= 60 and unit.efficiency >= 50 then
															
		
														table.insert(returnValues, {{ahex.x, ahex.y}, {112, 23}, "advance"})
														LogUi("ASSAULTING WARSAW")
																break
																					
														end
												end
											
				end
			end			 	      
		end
				
	end
	if game.turn >= 5 then -- AI scripted targeting
				LogUi("SCRIPTED TARGETING START")

				for faction in cp.factions do
						for unit in faction.units do
						
							if unit.hex ~= nil 
							and unit.prototype.name == "artillery" 
							and unit.efficiency ~= nil 
							and unit.hp >= 70 
							and faction.am >= 10 
							and unit.ap >0 then
											
											local enemyinrange = 0	
								local adjacentHexes = game.map:GetHexesInRange(unit.hex, 1)
									for _, hex in pairs(adjacentHexes) do
											if hex.unit ~= nil 
													and hex.unit.alive 
													and hex.unit.alliance.id ~= unit.alliance.id 
													and (hex.unit.prototype.name == "infantry" 
														or hex.unit.prototype.name == "cavalry") then
												enemyinrange = 1
												break
											end
									end		
											
											
											
											local ahex = unit.hex
											local hexes = game.map:GetHexesInRange(ahex, 2)
												for _, bhex in pairs(hexes) do
														if bhex.unit ~= nil 
														and bhex.unit.type == Unit.LAND 
														and bhex.unit.alliance.id == 1 
														and enemyinrange == 0
														and ((bhex.construction ~= nil and bhex.unit.hp >= 40) 
															or ((bhex.unit.prototype.name == "infantry" and bhex.unit.hp >= 50) 
															or bhex.unit.prototype.name ~= "infantry" and bhex.unit.commander ~= nil))
														then
																	LogUi("CHECKING ARTY FROM:" .. ahex.x ..  "/" .. ahex.y .. "TO:" .. bhex.x .. "/" .. bhex.y)
																		
																			table.insert(returnValues,{{ahex.x, ahex.y}, {bhex.x, bhex.y}})
																			break
																					
																					
							
														end
												end		
								
							end
							if unit.hex ~= nil 
							and unit.prototype.name == "fighter" 
							and unit.hp >= 60 and unit.efficiency ~= nil 
							and unit.efficiency >= 50 
							and unit.ap >0 then
										local enemyinrange = 0	
								local adjacentHexes = game.map:GetHexesInRange(unit.hex, 2)
									for _, hex in pairs(adjacentHexes) do
											if hex.unit ~= nil 
													and hex.unit.alive 
													and hex.unit.alliance.id ~= unit.alliance.id 
													and (hex.unit.prototype.name == "infantry" 
														or hex.unit.prototype.name == "cavalry") then
												enemyinrange = 1
												break
											end
									end		
											local ahex = unit.hex
											local hexes = game.map:GetHexesInRange(ahex, 5)
												for _, bhex in pairs(hexes) do
														if bhex.unit ~= nil 
														and bhex.unit.type == Unit.LAND 
														and bhex.unit.alliance.id == 1
														and enemyinrange == 0 														
														and ((bhex.construction ~= nil and bhex.unit.hp >= 60) 
															or ((bhex.unit.prototype.name == "infantry" and bhex.unit.hp >= 50) 
															or bhex.unit.prototype.name ~= "infantry" and bhex.unit.commander ~= nil))
														then
																	LogUi("CHECKING FIGHTER FROM:" .. ahex.x ..  "/" .. ahex.y .. "TO:" .. bhex.x .. "/" .. bhex.y)
																		
																			table.insert(returnValues,{{ahex.x, ahex.y}, {bhex.x, bhex.y}})
																			break
																					
																					
							
														end
												end		
							end
							if unit.hex ~= nil 
							and (unit.prototype.name == "zeppelin" or unit.prototype.name == "bomber") 
							and unit.hp >= 60 
							and unit.ap >0 
							and unit.efficiency ~= nil 
							and unit.efficiency >= 40 
							and unit.faction.am >= 22 then
								local enemyinrange = 0	
								local adjacentHexes = game.map:GetHexesInRange(unit.hex, 2)
									for _, hex in pairs(adjacentHexes) do
											if hex.unit ~= nil 
													and hex.unit.alive 
													and hex.unit.alliance.id ~= unit.alliance.id 
													and (hex.unit.prototype.name == "infantry" 
														or hex.unit.prototype.name == "cavalry") then
												enemyinrange = 1
												break
											end
									end		
											local ahex = unit.hex
											local hexes = game.map:GetHexesInRange(ahex, 16)
											if unit.prototype.name == "bomber" then
												hexes = game.map:GetHexesInRange(ahex, 14)
											end
												for _, bhex in pairs(hexes) do
													--	if bhex.unit ~= nil 
													--	and bhex.unit.type == Unit.LAND 
													--	and bhex.unit.alliance.id == 1 
														if bhex.terrain.type ~= Terrain.WATER
														and (bhex.construction ~= nil 
														and bhex.construction.efficency ~= nil
														and bhex.construction.efficency > 50) 
														and bhex.alliance ~= nil and bhex.alliance.id == 1
														and enemyinrange == 0
														then
																LogUi("CHECKING ZEP/BOMBER FROM:" .. ahex.x ..  "/" .. ahex.y .. "TO:" .. bhex.x .. "/" .. bhex.y)
																		
																			table.insert(returnValues,{{ahex.x, ahex.y}, {bhex.x, bhex.y}})
																			break
																					
																					
							
														end
												end		
							end
						
						end	
				end
		
		
				LogUi("SCRIPTED TARGETING END")

		end
		
		return returnValues
end		
	end
	
 end





function scriptedHostileNeutral(faction, approxTurnsToDeclaration)
  if faction.id == 5 and approxTurnsToDeclaration < 6 then
    return true
  end
  
  --[[if faction.id == 4 and approxTurnsToDeclaration ~= 1 then
    return false
  end--]]
end

function scriptedSpareAllocation(unit,aiPlayer)
        local france = game:GetFactionById(1)
        local germany = game:GetFactionById(2)
		local finland = game:GetFactionById(13)
		local bulgaria = game:GetFactionById(19)
		local italy = game:GetFactionById(8)
		local serbia = game:GetFactionById(7)


		local russia = game:GetFactionById(4)
		local paris = GetHex(82,30)
		local verdun = GetHex(87,29)
		local berlin = game:GetHex(101,22)
		local vienna = game:GetHex(104,31)
		local budapest = game:GetHex(108,33)
		local belgrade = GetHex(109,38)


--------------------------- PLAYER IS CP!!!!
  if playerAlliance.id == 2 then
  
    if unit.hex ~= nil 
		and unit.type == Unit.LAND 
		and unit.range == 1 
		and belgrade.alliance.id == 2 
		and serbia.alliance.id == 1 
		and italy.alliance.id == 1 
		and (unit.hex.originalFaction.id == 0 
		and unit.hex:Distance(verdun) >= 7) then
   --   if GetFactionTransportmoves(unit.faction) > 0 then
        local front = aiPlayer:getNearestEnemyFront(paris)
        local westernBalance = front.strength/front.enemyStrength
			if aiPlayer:getDistanceToFront(paris,front) < 10 and westernBalance > 1.5 then
				local serbia = GetHex(109,42)
				local serbianFront = aiPlayer:getNearestEnemyFront(serbia)
				local serbianBalance = serbianFront.strength/serbianFront.enemyStrength
					if aiPlayer:getDistanceToFront(serbia,serbianFront) < 4 and serbianBalance < 1.25 then
						--View:AddEffect(unit.hex, "marker_front")
						return serbianFront
					end
			end
    --  end
    end

				if france.alliance.id == 1 then
				  if unit.hex ~= nil and unit.hex.originalFaction.id == 0 and unit.hex.y < 32 then
					return aiPlayer:getNearestEnemyFront(verdun)
				  end
				end
			  end
  
    if unit.hex ~= nil and unit.range == 1 and (unit.hex.originalFaction.id == 4 or unit.hex.originalFaction.id == 3)  and russia.alliance.id == 1 then
     
	 if budapest.alliance.id == 2 then
        local front = aiPlayer:getNearestEnemyFront(budapest)
        local easternBalance = front.strength/front.enemyStrength
			if aiPlayer:getDistanceToFront(budapest,front) < 10 and easternBalance > 1.2 then
				local buda = GetHex(108,33)
				local budaFront = aiPlayer:getNearestEnemyFront(buda)
				local budaBalance = budaFront.strength/budaFront.enemyStrength
					if aiPlayer:getDistanceToFront(buda,budaFront) < 4 and budaBalance < 1.25 then
						--View:AddEffect(unit.hex, "marker_front")
						return budaFront
					end
			end
    elseif vienna.alliance.id  == 2 then
		local front = aiPlayer:getNearestEnemyFront(vienna)
        local easternBalance = front.strength/front.enemyStrength
			if aiPlayer:getDistanceToFront(vienna,front) < 10 and easternBalance > 1.2 then
				local wien = GetHex(104,32)
				local wienFront = aiPlayer:getNearestEnemyFront(wien)
				local wienBalance = wienFront.strength/wienFront.enemyStrength
					if aiPlayer:getDistanceToFront(wien,wienFront) < 4 and wienBalance < 1.25 then
						--View:AddEffect(unit.hex, "marker_front")
						return wienFront
					end
			end
	
	
	
	end
	end
  
  
 
  
  ---PLAYER IS ENTENTE!!!---------------------------------------------------------------------------------------------------------------------------
  if playerAlliance.id == 1 then
    local paris = GetHex(82,30)
    local verdun = GetHex(87,29)
	local warsaw = GetHex(112,23)
	local belgrade = GetHex(109,38)
	local france = game:GetFactionById(0)
	local germany = game:GetFactionById(2)
	local britain = game:GetFactionById(1)

	local austria = game:GetFactionById(3)

	local russia = game:GetFactionById(4)
	local turkey = game:GetFactionById(5)

	local serbia = game:GetFactionById(7)
	local suez = game:GetHex(129,68)
	local cairo = game:GetHex(127,67)
	local alexandria = game:GetHex(125,66)

	
	
    if unit.hex ~= nil and unit.type == Unit.LAND 
		and unit.range == 1 
		and GetEvent("DOWgermany") >0 
		and unit.faction.id == 2 
		and GetEvent("Surrenderfrance") <= 0 -- this
		and GetEvent("Surrenderbritain") <= 0 -- is
		and GetEvent("Surrenderrussia") <= 0 -- new
		and  unit.hex:Distance(verdun) >= 7    then ---(unit.hex.originalFaction.id == 2 or unit.hex:Distance(verdun) <= 5) then
   
        local front = aiPlayer:getNearestEnemyFront(paris)
        local westernBalance = front.strength/front.enemyStrength
				
				if 	(aiPlayer:getDistanceToFront(paris,front) <= 1
					and russia.alliance.id == 1 
					and ((westernBalance >= 1.5  and game.date.year == 1914) 
						or (((france.luaData.outcome ~= -1 
						or game.date.year >= 1915)) 
						and westernBalance >= 1.3))) 
					
				or (aiPlayer:getDistanceToFront(paris,front) <= 1 
					and westernBalance >= 1.2 
					and russia.alliance.id == 1 
					and  (GetEvent("Rupprecht") >0 or GetEvent("AllEast") >0))  then
								LogUi("WESTFRONT IS SAFE: GOING FOR RUSSIA WITH GERMANY")
								local russtarget = GetHex(112,23)
									if russtarget.alliance.id ==  2 then
										russtarget = GetHex(119,18)
										LogUi("WARSAW IS SAFE GOING TO VILNA")
									end
									if russtarget.alliance.id ==  2 then
										russtarget = GetHex(118,24)
										LogUi("WARSAW IS SAFE GOING TO RIGA")

									end
									if russtarget.alliance.id ==  2 then
										russtarget = GetHex(123,19)
										LogUi("RIGA IS SAFE GOING TO MINSK")

									end
									if russtarget.alliance.id ==  2 then
										russtarget = GetHex(125,7)
										LogUi("RIGA IS SAFE GOING TO PETROGRAD")

									end
									if finland.alliance.id == 2 then
										local kiev = GetHex(127,27)
										local odessa = GetHex(125,35)
										local rostov = GetHex(140,33)
											if kiev.alliance.id == 1 then
											russtarget = GetHex(125,27)
											elseif kiev.alliance.id == 2 and odessa.alliance.id == 1 then
												
												russtarget = GetHex(125,35)
											elseif odessa.alliance.id == 2 then
											russtarget = GetHex(140,33)
												
											end

									end

								
								local russianfront = aiPlayer:getNearestEnemyFront(russtarget)
								local russianbalance = russianfront.strength/russianfront.enemyStrength
									if aiPlayer:getDistanceToFront(russtarget,russianfront) <= 12 and russianbalance < 1.35 then
										--View:AddEffect(unit.hex, "marker_front")
										LogUi("RUSSIANFRONT1")

										return russianfront
									
									end
							
									

						if germany.alliance.id == 2 and paris.alliance.id == 1 then
							if unit.hex ~= nil and unit.hex.originalFaction.id == 2 and unit.hex.y < 34 then
									LogUi("PARISFRONT 1")

								return aiPlayer:getNearestEnemyFront(paris)

							end
						end

			end	

	
    
 

    
  ---------------- balkan
  
  elseif unit.hex ~= nil and unit.type == Unit.LAND and austria.alliance.id == 2 and unit.range == 1 and belgrade.alliance.id ~= 2 and russia.alliance.id == 1 and ((unit.faction.id == 3 and unit.hex:Distance(belgrade) <= 3 ) or unit.faction.id == 19 and bulgaria.alliance.id ==2) then
      
	  
	 
        local front = aiPlayer:getNearestEnemyFront(belgrade)
        local balkanbalance = front.strength/front.enemyStrength
		



	if aiPlayer:getDistanceToFront(belgrade,front) <= 1 and ((balkanbalance >= 1.35  and game.date.year >= 1915) or (belgrade.alliance.id == 2 and balkanbalance >= 1.2)) and russia.alliance.id == 1 then
				LogUi("BALKAN IS SAFE: GOING FOR LEMBERG WITH AUSTRIA")
				local russtarget = GetHex(115,28)
				
					if russtarget.alliance.id ==  2 then
						russtarget = GetHex(117,29)
						LogUi("LEMBERG IS SAFE: GOING FOR CZERNO WITH AUSTRIA")	
					end
					if russtarget.alliance.id ==  2 then
						russtarget = GetHex(118,28)
						LogUi("CZERNO IS SAFE: GOING FOR TARNOPOL WITH AUSTRIA")	
					end
					if russtarget.alliance.id ==  2 then
						russtarget = GetHex(120,27)
						LogUi("TARNOPOL IS SAFE: GOING FOR ROVNO WITH AUSTRIA")	

					end
					if russtarget.alliance.id ==  2 then
						russtarget = GetHex(127,27)
						LogUi("ROVNO IS SAFE: GOING FOR KIEV WITH AUSTRIA")	
					end
				

				local russianfront = aiPlayer:getNearestEnemyFront(russtarget)
					local russianbalance = russianfront.strength/russianfront.enemyStrength
					if aiPlayer:getDistanceToFront(russtarget,russianfront) <= 12 and russianbalance < 1.25 then
						--View:AddEffect(unit.hex, "marker_front")
						LogUi("RUSSIAN FRONT 2")
						return russianfront
					end
		
			end
      -------------- SINAI FRONT -------------------
      elseif unit.hex ~= nil and unit.type == Unit.LAND 
		and unit.range == 1 
		and turkey.alliance.id == 2 
		and unit.faction.id == 5
		and britain.alliance.id == 1	
		and unit.hex:Distance(suez) <= 8  then
			 local front = aiPlayer:getNearestEnemyFront(suez)
			local sinaibalance = front.strength/front.enemyStrength
			
			
		if  suez.alliance.id == 1 then
			
				local turktarget = suez.hex
				
		elseif cairo.alliance.id == 1 then
				
				local turktarget = cairo.hex
			
		elseif alexandria.alliance.id == 1 then

				local turktarget = alexandria.hex
			

				local turkfront = aiPlayer:getNearestEnemyFront(turktarget)
					local sinaibalance = turkfront.strength/turkfront.enemyStrength
					if aiPlayer:getDistanceToFront(turktarget,turkfront) <= 8 and sinaibalance >= 2 then
						--View:AddEffect(unit.hex, "marker_front")
					
						return turkfront
					end
		
			end	
	
	
	
	end
	
	if germany.alliance.id == 2 and paris.alliance.id == 1 then
			if unit.hex ~= nil and unit.type == Unit.LAND and unit.faction.id == 2 then --and unit.hex.y < 34 then
								--	LogUi("PARIS FRONT")

				return aiPlayer:getNearestEnemyFront(paris)
			end
		end
  end
end

function scriptedNavalDeployInvasions()
  local invasions = {}
  if playerAlliance.id == 2 then
    invasions = {
      {
        1, --no of units to buy & deploy
        7, --target game turn to deploy invasion units
        {GetHex(81,27),GetHex(79,28)}, -- target hexes
        2, --unit type id
        1, --faction id
        {GetHex(76,75),GetHex(79,23)}, --deploy hexes
        0 --isInvasion  
      }
    }
  end
  return invasions
end

--[[
1 = garrison
2 = infantry
3 = armour
4 = artillery
5 = railgun
6 = armouredtrain
7 = lightcruiser
8 = dreadnought
9 = submarine
12 = fighter
13 = bomber
14 = zeppelin
15 = armoured car
16 = cav
--]]

function scriptedDontBuy(faction)
  if game.turn == 1 and faction.id == 3 and math.random(1,4) == 3 then
    return true
  end
end

function scriptedBuyAndDeploy()
  local units = {}
  if playerAlliance.id == 1 then
    -- CP AI
    units = {
      {
        1, --no of units to buy & deploy
        5, --target game turn to deploy
        {GetHex(111,37),GetHex(107,40),GetHex(107,39),GetHex(112,37)}, -- deploy hexes (in order or priority)
        2, --unit type id 
        3 --faction id
      },
      {
        1, --no of units to buy & deploy
        6, --target game turn to deploy
        {GetHex(110,28),GetHex(105,39)}, -- deploy hexes (in order or priority)
        2, --unit type id 
        3 --faction id
      },
      {
        1, --no of units to buy & deploy
        7, --target game turn to deploy
        {GetHex(110,28), GetHex(111,27), GetHex(109,27)}, -- deploy hexes (in order or priority)
        2, --unit type id
        3 --faction id
      },
	     {
        2, --no of units to buy & deploy
        5, --target game turn to deploy
        {GetHex(108,22),GetHex(113,17), GetHex(110,21), GetHex(106,25), GetHex(108,26), GetHex(107,22)}, -- deploy hexes (in order or priority)
        1, --unit type id
        2 --faction id
      },
      {
        1, --no of units to buy & deploy
        7, --target game turn to deploy
        {GetHex(90,25),GetHex(91,27)}, -- deploy hexes (in order or priority)
        2, --unit type id
        2 --faction id
      },
   
      {
        2, --no of units to buy & deploy
        8, --target game turn to deploy
        {GetHex(110,20),GetHex(90,25),GetHex(90,27)}, -- deploy hexes (in order or priority)
        2, --unit type id
        2 --faction id
      },
    }  elseif playerAlliance.id == 2 then
    -- Entente AI
    units = {
      {
        2, --no of units to buy & deploy
        4, --target game turn to deploy
        {GetHex(82,26),GetHex(82,30),GetHex(80,28)}, -- deploy hexes (in order or priority)
        1, --unit type id
        0 --faction id
      },
      {
        2, --no of units to buy & deploy
        6, --target game turn to deploy
        {GetHex(82,26),GetHex(82,29),GetHex(83,29),GetHex(82,30),GetHex(81,28)}, -- deploy hexes (in order or priority)
        2, --unit type id
        0 --faction id
      },
      {
        1, --no of units to buy & deploy
        7, --target game turn to deploy
        {GetHex(79,23),GetHex(76,25),GetHex(71,25)}, -- deploy hexes (in order or priority)
        2, --unit type id
        1 --faction id
      },
    }
  end
  return units
end